#! /bin/sh
#
# urandom	This script saves the random seed between reboots.
#		It is called from the boot, halt and reboot scripts.
#
# Version:	@(#)urandom  1.33  22-Jun-1998  miquels@cistron.nl
#
me="[$(printf $0 | xargs basename)]"

[ -c /dev/urandom ] || exit 0

RANDOM_SEED_FILE="/opt/userdata/random-seed"

case "$1" in
	start|"")
		printf "${me} Initializing random number generator. \\n"
		# Load and then save 512 bytes,
		# which is the size of the entropy pool
		if [ -f "${RANDOM_SEED_FILE}" ]; then
			cat "${RANDOM_SEED_FILE}" >/dev/urandom
		fi
		# check for read only file system
		if ! touch ${RANDOM_SEED_FILE} 2>/dev/null; then
			printf "${me} read-only file system detected...done\\n"
			exit
		fi
		rm -f ${RANDOM_SEED_FILE}
		umask 077
		dd if=/dev/urandom of=${RANDOM_SEED_FILE} count=1 \
			>/dev/null 2>&1 || printf "${me} urandom start: failed.\\n"
		umask 022
		printf "${me} Initializing random number generator done. \\n"
		;;
	stop)
		if ! touch ${RANDOM_SEED_FILE} 2>/dev/null; then
			exit
		fi
		# Carry a random seed from shut-down to start-up;
		# see documentation in linux/drivers/char/random.c
    printf "${me} Saving random seed \\n"
		umask 077
		dd if=/dev/urandom of=${RANDOM_SEED_FILE} count=1 >/dev/null 2>&1 || printf "urandom stop: failed.\\n"
		printf "${me} Saving random seed done. \\n"
		;;
	*)
		printf "Usage: urandom {start|stop}\\n" >&2
		exit 1
		;;
esac
